# -*- coding: utf8 -*-
from __future__ import unicode_literals

from driverng.tests import BaseTest


class TestProtocolAbx(BaseTest):
    PROTOCOL_CLASS = "abx"
    PROTOCOL_KWARGS = {"encoding": "latin1"}

    def test_send_recv(self):
        self.assertSendMessageEqual(
            """\xff RESULT  \r! 005.4  \r" 01.56 l\r# 029.1  \r$ 00.35  \r% 006.5  \r( 03.34  \r) 062.2  \r* 00.11  \r+ 002.0  \r, 00.01  \r- 000.2  \r. 00.02  \r/ 000.4  \r0 00.09  \r1 001.8  \r2 02.54 L\r3 009.8 l\r4 028.2 L\r5 00111 h\r6 038.7 H\r7 034.9  \r8 011.2  \r@ 00173  \rA 008.3  \rB 0.144  \rC 014.3  \rP             \rQ                          \rR     \rS       \rT\rU\rV\rW        !$&)/Dq\xae\xf0\xff\xea\xc7\xaf\x92zeWWSMOQ]hgjy~~\x81\x8c\x93\x92\x8b\x93\x8e\x94\x8f\x8b\x90\x8f\x94\x8f\x86ue^`cVTQHBC;5840/-*,,*%$%&$$$#     !                                         \rX        %&&$""!!        !!$&)/:J`u\x90\xb2\xd5\xde\xf1\xff\xf9\xe5\xd2\xbb\xad\x96\x81lXE81*$                                                                           \rY        %*9Mav\x8f\xa8\xc2\xd6\xea\xf4\xf9\xf4\xf4\xf4\xf9\xff\xff\xf4\xea\xe5\xe5\xe5\xe0\xdb\xd6\xc7\xb8\xa3\x99\x8f\x8a\x85\x80\x80{vl\\WRRRMHC>>>>94//**%%%******%%%%%%%%%%%                                            \rZ            !  "*@@@@@@@@@@@@@>30.+\\'%%#$"##"!!!!! !!! ! !                                                                        \r] 002 007 120 000 000\r^ 024 048\r_ 098\r` 009 067 120\ra 022 025 048 035 118 030 068 078 090 070 090 118 029 069 051 002 002 002\rf               \rg       \rp 01\rq 01/04/14 12h08mn21s\rr 101DIF04        \rs 0105\rt R\ru 460104018458    \rv LOMBERGET MONIQUE             \rw 19340616\rx 79y\ry  \rz  \r{                \r|           \r} 01/04/14 09h49\r~                                 \r\x7f standard        \r\x80 B\r\x81 0\r\x82 1\r\x83 de \r\xfb VEGA    \r\xfe V3.1 \n""",
            """
            send <soh>
            recv <enq>
            send <stx>01298<cr>\\xff RESULT  <cr>! 005.4  <cr>" 01.56 l<cr># 029.1  <cr>$ 00.35  <cr>% 006.5  <cr>( 03.34  <cr>) 062.2  <cr>* 00.11  <cr>+ 002.0  <cr>, 00.01  <cr>- 000.2  <cr>. 00.02  <cr>/ 000.4  <cr>0 00.09  <cr>1 001.8  <cr>2 02.54 L<cr>3 009.8 l<cr>4 028.2 L<cr>5 00111 h<cr>6 038.7 H<cr>7 034.9  <cr>8 011.2  <cr>@ 00173  <cr>A 008.3  <cr>B 0.144  <cr>C 014.3  <cr>P             <cr>Q                          <cr>R     <cr>S       <cr>T<cr>U<cr>V<cr>W        !$&)/Dq\\xae\\xf0\\xff\\xea\\xc7\\xaf\\x92zeWWSMOQ]hgjy~~\\x81\\x8c\\x93\\x92\\x8b\\x93\\x8e\\x94\\x8f\\x8b\\x90\\x8f\\x94\\x8f\\x86ue^`cVTQHBC;5840/-*,,*%$%&$$$#     !                                         <cr>X        %&&$""!!        !!$&)/:J`u\\x90\\xb2\\xd5\\xde\\xf1\\xff\\xf9\\xe5\\xd2\\xbb\\xad\\x96\\x81lXE81*$                                                                           <cr>Y        %*9Mav\\x8f\\xa8\\xc2\\xd6\\xea\\xf4\\xf9\\xf4\\xf4\\xf4\\xf9\\xff\\xff\\xf4\\xea\\xe5\\xe5\\xe5\\xe0\\xdb\\xd6\\xc7\\xb8\\xa3\\x99\\x8f\\x8a\\x85\\x80\\x80{vl\\WRRRMHC>>>>94//**%%%******%%%%%%%%%%%                                            <cr>Z            !  "*@@@@@@@@@@@@@>30.+\\'%%#$"##"!!!!! !!! ! !                                                                        <cr>] 002 007 120 000 000<cr>^ 024 048<cr>_ 098<cr>` 009 067 120<cr>a 022 025 048 035 118 030 068 078 090 070 090 118 029 069 051 002 002 002<cr>f               <cr>g       <cr>p 01<cr>q 01/04/14 12h08mn21s<cr>r 101DIF04        <cr>s 0105<cr>t R<cr>u 460104018458    <cr>v LOMBERGET MONIQUE             <cr>w 19340616<cr>x 79y<cr>y  <cr>z  <cr>{                <cr>|           <cr>} 01/04/14 09h49<cr>~                                 <cr><del> standard        <cr>\\x80 B<cr>\\x81 0<cr>\\x82 1<cr>\\x83 de <cr>\\xfb VEGA    <cr>\\xfe V3.1 \\xfd 0414<cr><etx>
            recv <ack>
            send <stx>00024<cr>\\xff END     <cr>\\xfd 03A6<cr><etx>
            recv <ack>
            """,
        )
