# -*- coding: utf8 -*-
from __future__ import unicode_literals

import datetime

parser_class = "ssa"


def test_encode_order(self):
    message = self.order()
    expected = """
    H|\\^&
    P|1||036666666||NYME^ANO|NJF|20110513|F
    O|1|123456||^^^SERO|R|20130603110342|||||N||||||||||||||O
    R|1|^^A^SERO|||||F
    R|2|^^B^SERO|||||F
    L|1"""
    assert message == expected


def test_decode_result(self):
    worklist = self.decode(
        """
    H|\\^&
    P|1|173164|0302047932||ANO^NYME||19510426|M
    O|1|0005023008||^^^SERO|R|||||||||||||||||||AppareilSSA|F
    R|1|^^SERO1^SERO|00528366^C3|µl|500|N|F|Cindy|201302201041|201302201057|200
    P|2|173165|0302016514||NYME^ANO||19611030|M
    O|1|0005016010||^^^SERO|R|||||||||||||||||||AppareilSSA|F
    R|1|^^SERO1^SERO|00528366|µl|500|N|F|Cindy|201302201041|201302201057|200
    L|1|N^6180^^"""
    )
    date = datetime.datetime(2013, 2, 20, 10, 57)
    expected = {
        "context": "result",
        "samples": [
            {
                "sample_id": "0005023008",
                "type": "patient",
                "results": [
                    {
                        "code": "SERO1",
                        "date": date,
                        "flags": ["N"],
                        "value": "00528366-C3",
                        "operator": "Cindy",
                    }
                ],
            },
            {
                "sample_id": "0005016010",
                "type": "patient",
                "results": [
                    {
                        "code": "SERO1",
                        "date": date,
                        "flags": ["N"],
                        "value": "00528366",
                        "operator": "Cindy",
                    }
                ],
            },
        ],
    }
    assert worklist == expected
